'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _desc, _value, _class;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _diff = require('diff');

var diff = _interopRequireWildcard(_diff);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _fastMemoize = require('fast-memoize');

var _fastMemoize2 = _interopRequireDefault(_fastMemoize);

var _pMap = require('p-map');

var _pMap2 = _interopRequireDefault(_pMap);

var _lodash = require('lodash.uniq');

var _lodash2 = _interopRequireDefault(_lodash);

var _case = require('case');

var _case2 = _interopRequireDefault(_case);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _windowSize = require('window-size');

var _windowSize2 = _interopRequireDefault(_windowSize);

var _coreDecorators = require('core-decorators');

var _compiler = require('./compiler');

var _compiler2 = _interopRequireDefault(_compiler);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

const diffChars = (0, _fastMemoize2.default)(diff.diffChars);

let Section = (_dec = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec2 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec3 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec4 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec5 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec6 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec7 = (0, _coreDecorators.decorate)(_fastMemoize2.default), _dec8 = (0, _coreDecorators.decorate)(_fastMemoize2.default), (_class = class Section {

  constructor(main, name, description = '', postcssPlugins) {
    this.main = main;
    this.name = name;
    this.title = _case2.default.capital(name);
    this.description = (0, _marked2.default)(description);
    this.postcssPlugins = postcssPlugins;
    this.html = '';
    this.items = {};
    this.altItems = {};
    this.altCompiledItems = {};
    this.dirname = {};
    this.filename = {};
  }

  get data() {
    return {
      main: this.main,
      name: this.name,
      title: this.title,
      description: this.description,
      html: this.html,
      items: this.items,
      altItems: this.altItems
    };
  }

  get css() {
    switch (this.main) {
      default:
      case 'css':
        {
          return this.items.css;
        }
      case 'postcss':
        {
          if (typeof this.altCompiledItems.postcss === 'undefined') {
            throw new TypeError(`
${this.__getAltFilename(this.filename.postcss)} was not found.
          `.trim());
          }
          return this.altCompiledItems.postcss;
        }
      case 'scss':
        {
          if (typeof this.altCompiledItems.scss === 'undefined') {
            throw new TypeError(`
${this.__getAltFilename(this.filename.scss)} was not found.
          `.trim());
          }
          return this.altCompiledItems.scss;
        }
      case 'less':
        {
          if (typeof this.altCompiledItems.less === 'undefined') {
            throw new TypeError(`
${this.__getAltFilename(this.filename.less)} was not found.
          `.trim());
          }
          return this.altCompiledItems.less;
        }
      case 'stylus':
        {
          if (typeof this.altCompiledItems.stylus === 'undefined') {
            throw new TypeError(`
${this.__getAltFilename(this.filename.stylus)} was not found.
          `.trim());
          }
          return this.altCompiledItems.stylus;
        }
    }
  }

  set(target, contents, filename) {
    if (target === 'html') {
      this.html = contents;
      return;
    }

    this.items[target] = contents;
    this.dirname[target] = _path2.default.dirname(filename);
    this.filename[target] = filename;
  }

  __compilePostcss(content, plugins) {
    return _asyncToGenerator(function* () {
      const compiled = yield _compiler2.default.postcss(content, plugins);
      return compiled;
    })();
  }

  __compileScss(content, dirname) {
    return _asyncToGenerator(function* () {
      const compiled = yield _compiler2.default.scss(content, dirname);
      return compiled;
    })();
  }

  __compileLess(content, dirname) {
    return _asyncToGenerator(function* () {
      const compiled = yield _compiler2.default.less(content, dirname);
      return compiled;
    })();
  }

  __compileStylus(content, dirname) {
    return _asyncToGenerator(function* () {
      const compiled = yield _compiler2.default.stylus(content, dirname);
      return compiled;
    })();
  }

  standardize(content) {
    return _asyncToGenerator(function* () {
      const min = yield _compiler2.default.standardize(content);
      return min;
    })();
  }

  compile() {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (typeof _this.items.postcss !== 'undefined') {
        const altFilename = _this.__getAltFilename(_this.filename.postcss);
        yield _fsExtra2.default.access(altFilename, _fsExtra2.default.constants.F_OK);
        const altCode = yield _fsExtra2.default.readFile(altFilename, 'utf-8');
        _this.altItems.postcss = altCode;
        const content = yield _this.__compilePostcss(altCode, _this.postcssPlugins);
        _this.altCompiledItems.postcss = content;
      }
      if (typeof _this.items.scss !== 'undefined') {
        const altFilename = _this.__getAltFilename(_this.filename.scss);
        yield _fsExtra2.default.access(altFilename, _fsExtra2.default.constants.F_OK);
        const altCode = yield _fsExtra2.default.readFile(altFilename, 'utf-8');
        _this.altItems.scss = altCode;

        const dirname = _this.dirname.scss;
        const content = yield _this.__compileScss(altCode, dirname);
        _this.altCompiledItems.scss = content;
      }
      if (typeof _this.items.less !== 'undefined') {
        const altFilename = _this.__getAltFilename(_this.filename.less);
        yield _fsExtra2.default.access(altFilename, _fsExtra2.default.constants.F_OK);
        const altCode = yield _fsExtra2.default.readFile(altFilename, 'utf-8');
        _this.altItems.less = altCode;

        const dirname = _this.dirname.less;
        const content = yield _this.__compileLess(altCode, dirname);
        _this.altCompiledItems.less = content;
      }
      if (typeof _this.items.stylus !== 'undefined') {
        const altFilename = _this.__getAltFilename(_this.filename.stylus);
        yield _fsExtra2.default.access(altFilename, _fsExtra2.default.constants.F_OK);
        const altCode = yield _fsExtra2.default.readFile(altFilename, 'utf-8');
        _this.altItems.less = altCode;

        const dirname = _this.dirname.stylus;
        const content = yield _this.__compileStylus(altCode, dirname);
        _this.altCompiledItems.stylus = content;
      }

      const result = Object.keys(_this.altCompiledItems).reduce(function ($result, target) {
        const targetCode = _this.altCompiledItems[target];
        if (targetCode === '') {
          return $result;
        }
        $result[target] = targetCode;
        return $result;
      }, {});
      return result;
    })();
  }

  isValid(targetData) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const targets = function () {
        const $targets = Object.keys(targetData);
        if (_this2.main === 'css') {
          return ['css', ...$targets];
        }
        return $targets;
      }();
      if (targets.length < 2) {
        return true;
      }

      const rawContents = yield _asyncToGenerator(function* () {
        const $rawContents = Object.values(targetData);
        if (_this2.main === 'css') {
          const cssContents = _this2.standardize(_this2.items.css);
          return [cssContents, ...$rawContents];
        }
        return $rawContents;
      })();
      const contents = yield (0, _pMap2.default)(rawContents, (() => {
        var _ref2 = _asyncToGenerator(function* (c) {
          const min = yield _this2.standardize(c);
          return min;
        });

        return function (_x) {
          return _ref2.apply(this, arguments);
        };
      })());

      if ((0, _lodash2.default)(contents).length !== 1) {
        const first = _chalk2.default.gray(contents[0]);
        const contents$ = contents.slice(1).map(function (c) {
          const diffs = diffChars(first, c);
          diffs.forEach(function (d) {
            if (d.added) {
              c = c.replace(d.value, _chalk2.default.yellow(d.value));
            }
          });
          return _chalk2.default.gray(c);
        });
        const line = _this2.__getLine(_windowSize2.default.width);
        throw new Error(`'${_this2.name}' section is missing.

${_chalk2.default.bold.blue(_this2.name)}
${line}
${_this2.__diffTable(targets, [first, ...contents$])}
${line}
      `);
      }
      return false;
    })();
  }

  __hasHTML() {
    return 'html' in this.items;
  }

  __getAltFilename(filename) {
    var _path$parse = _path2.default.parse(filename);

    const dir = _path$parse.dir,
          ext = _path$parse.ext;

    const base = _path2.default.basename(filename, ext);
    return dir + '/' + base + '$' + ext;
  }

  __getLine(width) {
    return _chalk2.default.gray(Array(width).fill('-').join(''));
  }

  __diffTable(targets, contents) {
    const rows = [];
    let n = 0;
    while (targets.length > n) {
      rows.push([_chalk2.default.blue('∎ ') + targets[n], contents[n]]);
      n++;
    }

    return rows.map(r => r.join('\n')).join('\n\n');
  }
}, (_applyDecoratedDescriptor(_class.prototype, '__compilePostcss', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, '__compilePostcss'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__compileScss', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, '__compileScss'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__compileLess', [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, '__compileLess'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__compileStylus', [_dec4], Object.getOwnPropertyDescriptor(_class.prototype, '__compileStylus'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'standardize', [_dec5], Object.getOwnPropertyDescriptor(_class.prototype, 'standardize'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__getAltFilename', [_dec6], Object.getOwnPropertyDescriptor(_class.prototype, '__getAltFilename'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__getLine', [_dec7], Object.getOwnPropertyDescriptor(_class.prototype, '__getLine'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '__diffTable', [_dec8], Object.getOwnPropertyDescriptor(_class.prototype, '__diffTable'), _class.prototype)), _class));
exports.default = Section;
module.exports = exports['default'];